; ##############################################################################
; ##############################################################################
; ##############################################################################
;																				
; ADC initialisieren mit "Free Run" und Vorteiler								
;																				
; 	ADEN: ADC Enable                             								
; 	ADSC: ADC Start Conversion                   								
; 	ADFR: ADC Free Running Select                								
; 	ADIF: ADC Interrzpt Flag                     								
; 	ADIE: ADC Interrupt Enable                   								
; 	ADPS2: Vorteiler                             								
; 	ADPS2: Vorteiler                             								
; 	ADPS2: Vorteiler                             								
;																				
;	ADPS2 ADPS1 ADPS0 Division Factor											
;	0 		0 	0 		2														
;	0 		0 	1 		2														
;	0 		1 	0 		4														
;	0 		1 	1 		8														
;	1 		0 	0 		16														
;	1 		0 	1	 	32														
; *	1 		1 	0 		64														
;	1 		1 	1 		128														
;																				
; ADC REFERENZ																	
; REFS1 REFS0 Voltage Reference Selection										
;  0     0    AREF, Internal Vref turned off									
; *0     1    AVCC with external capacitor at AREF pin							
;  1     1    Internal 2.56V Voltage Reference with external capacitor at AREF pin
;																				
;MUX3..0																		
;	0000 ADC0																	
;	0001 ADC1																	
;	0010 ADC2																	
;	0011 ADC3																	
;	0100 ADC4																	
;	0101 ADC5																	
;	0110 ADC6																	
;	0111 ADC7																	
;  *1110 1.23V (VBG)															
;	1111 0V (GND)																
ADC_INITIALISIERUNG_VBG:
	ldi temp, ((1<<ADEN)|(1<<ADSC)|(1<<ADFR)|(1<<ADPS2)|(1<<ADPS1)|(0<<ADPS0)) 
	out ADCSR, temp


	ldi temp, (0<<REFS1)|(1<<REFS0)|(0<<ADLAR)|(1<<MUX3)|(1<<MUX2)|(1<<MUX1)|(0<<MUX0)
	out ADMUX, temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ADC_MESSEN_BETRIEBSSPANNUNG:
.equ VBG=120 ; exemplarabhngig
	rcall ADC_MESSEN
	mov temp5,temp1
	mov temp6,temp2

	ldi temp1,BYTE1(VBG*100)
	ldi temp2,BYTE2(VBG*100)
	ldi temp3,BYTE3(VBG*100)
	ldi temp4,BYTE4(VBG*100)
	rcall DIVISION_32_16
	STS(adr_ADC_BETRIEBSSPANNUNG),temp1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ADC-WERT 256 mal einlesen und daraus den Mittelwert bilden					
;																				
; OUT: 	TEMP1 (low)  															
;		TEMP2																	
; 																				
ADC_MESSEN:
	clr temp3	; HILFSREGISTER CLEAR								
	clr temp4
	clr temp5
	clr temp6
	clr temp9	; SCHLEIFE initialisieren		
;-------------------------------------------------------------------------------
; neuen ADC-Wert lesen	 Wert verwerfen, da meist vom vorherigem ADC-Kanal		
	sbi ADCSRA, ADIF    		; logisch "1" lscht ADIF flag !	
ADC_MESSEN_w:                  
	sbis ADCSRA, ADIF			; warten bis ADIF flag gesetzt		
	rjmp ADC_MESSEN_w
;-------------------------------------------------------------------------------
; neuen ADC-Wert lesen	(Schleife - 256 mal)									
ADC_MESSEN_s:                
	sbi ADCSRA, ADIF    		; logisch "1" lscht ADIF flag !	
ADC_MESSEN_w2:                
	sbis ADCSR, ADIF 			; warten bis ADIF flag gesetzt		
	rjmp ADC_MESSEN_w2
;-------------------------------------------------------------------------------
; ADC einlesen:																	
	in  temp1, ADCL 			; immer zuerst LOW Byte lesen
	in  temp2, ADCH 			; danach das mittlerweile gesperrte High Byte
;-------------------------------------------------------------------------------
; alle 256 ADC-Werte addieren													
	add temp4,temp1     		; addieren  						
	adc temp5,temp2     		; addieren ber Carry  				
	adc temp6,NULL    	 		; addieren ber Carry  				
	dec temp9			 		; Schleifenzhler MINUS 1			
	brne ADC_MESSEN_s 			; ==> SCHLEIFE						
;-------------------------------------------------------------------------------
; MITTELWERT-BERECHNUNG	(128 addieren)											
	ldi temp,128
	add temp4,temp	     		; addieren  						
	adc temp5,NULL	     		; addieren ber Carry  				
	adc temp6,NULL    	 		; addieren ber Carry  				
;-------------------------------------------------------------------------------
; 	Ergebnis durch 256 teilen (temp5+6 nach temp1+2 kopieren)					
	mov temp1,temp5
	mov temp2,temp6
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
