; ##############################################################################
; ##############################################################################
; ##############################################################################
ASCII_TEMP:
	push temp1 							; sichern			
	push temp2
;-------------------------------------------------------------------------------
	ldi ZL,low (FONT*2)					; Z auf Tabelle		
	ldi ZH,high(FONT*2)
	ldi temp1,8
	mul temp,temp1						; x8				
	add ZL,R0							; Z addieren		
	adc ZH,R1
;-------------------------------------------------------------------------------
	rcall OLED_GOTO_XY
	rcall OLED_DATA_START				; Start				
;-------------------------------------------------------------------------------
	LDS R0,(adr_ASCII_FONT)
	cp R0,NULL
	breq ASCII8X8_TEMP
	cp R0,EINS
	breq ASCII8X16_TEMP
	rjmp ASCII16X16_TEMP 
; ##############################################################################
; ##############################################################################
; ##############################################################################
ASCII8X8_TEMP:
	ldi temp,8							; schleife			
	mov R0,temp
ASCII8X8_s:
	LPM temp1,Z+
	rcall ASCII_BITTAUSCH_TEMP1_TEMP	; BITTAUSCH			
	rcall TWI_MT_TX_TEMP				; TX				
	dec R0
	brne ASCII8X8_s
;-------------------------------------------------------------------------------
	pop temp2							; wieder herstellen	
	pop temp1
	rjmp ASCII_COUNTER8					; COUNTER			
; ##############################################################################
; ##############################################################################
; ##############################################################################
ASCII8X16_TEMP:
	ldi XL,low (adr_ASCII_BEREICH_OZ)
	ldi XH,high(adr_ASCII_BEREICH_OZ)
	ldi YL,low (adr_ASCII_BEREICH_UZ)
	ldi YH,high(adr_ASCII_BEREICH_UZ)
;-------------------------------------------------------------------------------
	ldi temp,8							; schleife			
	mov R0,temp
ASCII8X16_s:
	LPM temp1,Z+
	rcall ASCII_BITTAUSCH_TEMP1_TEMP	; BITTAUSCH		
	rcall ASCII_BITVERDOPPLUNG_TEMP_TEMP1_2	; Bitverdopplung
	ST X+,temp1
	ST Y+,temp2
	dec R0
	brne ASCII8X16_s
;-------------------------------------------------------------------------------
	ldi XL,low (adr_ASCII_BEREICH_OZ)
	ldi XH,high(adr_ASCII_BEREICH_OZ)
	ldi YL,low (adr_ASCII_BEREICH_UZ)
	ldi YH,high(adr_ASCII_BEREICH_UZ)
;-------------------------------------------------------------------------------
; TX obere ZEILE																
	ldi temp,8						; schleife			
	mov R0,temp
ASCII8X16_sX:
	LD temp,X+
	rcall TWI_MT_TX_TEMP			; TX				
	dec R0
	brne ASCII8X16_sX
;-------------------------------------------------------------------------------
	inc OLED_Y						; nchste Zeile		
	rcall OLED_GOTO_XY
	dec OLED_Y						; Zeile Zurck		
;-------------------------------------------------------------------------------
; TX untere ZEILE																
	ldi temp,8						; schleife			
	mov R0,temp
ASCII8X16_sY:
	LD temp,Y+
	rcall TWI_MT_TX_TEMP			; TX				
	dec R0
	brne ASCII8X16_sY
;-------------------------------------------------------------------------------
	pop temp2							; wieder herstellen	
	pop temp1
;-------------------------------------------------------------------------------
; X-Y-COUNTER																	
ASCII_COUNTER8:
	mov temp,OLED_X
	subi temp,(-8)					; +8
	cpi temp,127+1
	brsh ASCII8X16_w
	mov OLED_X,temp
	ret
ASCII8X16_w:
	clr OLED_X
	inc OLED_Y
	inc OLED_Y
	mov temp,OLED_Y
	cpi temp,7+1
	brsh ASCII8X16_NULL
	ret
ASCII8X16_NULL:
	clr OLED_X
	clr OLED_Y
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ASCII16X16_TEMP:
	ldi XL,low (adr_ASCII_BEREICH_OZ)
	ldi XH,high(adr_ASCII_BEREICH_OZ)
	ldi YL,low (adr_ASCII_BEREICH_UZ)
	ldi YH,high(adr_ASCII_BEREICH_UZ)
;-------------------------------------------------------------------------------
	ldi temp,8						; schleife			
	mov R0,temp
ASCII16X16_s:
	LPM temp1,Z+
	rcall ASCII_BITTAUSCH_TEMP1_TEMP		; BITTAUSCH		
	rcall ASCII_BITVERDOPPLUNG_TEMP_TEMP1_2	; Bitverdopplung
	ST X+,temp1
	ST Y+,temp2
	dec R0
	brne ASCII16X16_s
;-------------------------------------------------------------------------------
	ldi XL,low (adr_ASCII_BEREICH_OZ)
	ldi XH,high(adr_ASCII_BEREICH_OZ)
	ldi YL,low (adr_ASCII_BEREICH_UZ)
	ldi YH,high(adr_ASCII_BEREICH_UZ)
;-------------------------------------------------------------------------------
; TX obere ZEILE																
	ldi temp,8						; schleife			
	mov R0,temp
ASCII16X16_sX:
	LD temp,X+
	push temp
	rcall TWI_MT_TX_TEMP		; TX				
	pop temp
	rcall TWI_MT_TX_TEMP		; TX				
	dec R0
	brne ASCII16X16_sX
;-------------------------------------------------------------------------------
	inc OLED_Y					; nchste Zeile		
	rcall OLED_GOTO_XY
	dec OLED_Y					; Zeile Zurck		
;-------------------------------------------------------------------------------
; TX untere ZEILE																
	ldi temp,8						; schleife			
	mov R0,temp
ASCII16X16_sY:
	LD temp,Y+
	push temp
	rcall TWI_MT_TX_TEMP		; TX				
	pop temp
	rcall TWI_MT_TX_TEMP		; TX				
	dec R0
	brne ASCII16X16_sY
;-------------------------------------------------------------------------------
	pop temp2						; wieder herstellen	
	pop temp1
;-------------------------------------------------------------------------------
; X-Y-COUNTER																	
	mov temp,OLED_X
	subi temp,(-16)	; +16
	cpi temp,127+1
	brsh ASCII16X16_w
	mov OLED_X,temp
	ret
ASCII16X16_w:
	clr OLED_X
	inc OLED_Y
	inc OLED_Y
	mov temp,OLED_Y
	cpi temp,7+1
	brsh ASCII16X16_NULL
	ret
ASCII16X16_NULL:
	clr OLED_X
	clr OLED_Y
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Bittausch, Reihenfolge umkehren												
; Bsp: 0b00000001 ---> 0b10000000												
; steht schon auf dem Kopf														
ASCII_BITTAUSCH_TEMP1_TEMP:
	clr temp
	sbrc temp1,0  	;Skip if Bit in Register Cleared
	ori temp,0b10000000
	sbrc temp1,1  	;
	ori temp,0b01000000
	sbrc temp1,2  	;
	ori temp,0b00100000
	sbrc temp1,3  	;
	ori temp,0b00010000
	sbrc temp1,4  	;
	ori temp,0b00001000
	sbrc temp1,5  	;
	ori temp,0b00000100
	sbrc temp1,6  	;
	ori temp,0b00000010
	sbrc temp1,7  	;
	ori temp,0b00000001
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Bitverdopplung																
; Bsp: 0b00000001 ---> 0b00000011												
ASCII_BITVERDOPPLUNG_TEMP_TEMP1_2:
	clr temp1
	clr temp2
	sbrc temp,0  	;Skip if Bit in Register Cleared
	ori temp1,0b00000011
	sbrc temp,1
	ori temp1,0b00001100
	sbrc temp,2
	ori temp1,0b00110000
	sbrc temp,3
	ori temp1,0b11000000
	sbrc temp,4
	ori temp2,0b00000011
	sbrc temp,5
	ori temp2,0b00001100
	sbrc temp,6
	ori temp2,0b00110000
	sbrc temp,7
	ori temp2,0b11000000
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ASCII_TEXT_Z:
	LPM temp, Z+   			; aus Tabelle laden und Zeiger um 1 erhhen	
	tst temp  			
	brne ASCII_TEXT_w
	ret
;-------------------------------------------------------------------------------
ASCII_TEXT_w:
	push ZL
	push ZH
	rcall ASCII_TEMP			; Anzeige
	pop ZH
	pop ZL
	rjmp ASCII_TEXT_Z
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
ASCII_SPACE3:
	ldi temp,' '
	rcall ASCII_TEMP
ASCII_SPACE2:
	ldi temp,' '
	rcall ASCII_TEMP
ASCII_SPACE:
	ldi temp,' '
	rjmp ASCII_TEMP
; ##############################################################################
ASCII_PUNKT3:
	ldi temp,'.'
	rcall ASCII_TEMP
ASCII_PUNKT2:
	ldi temp,'.'
	rcall ASCII_TEMP
ASCII_PUNKT:
	ldi temp,'.'
	rjmp ASCII_TEMP
; ##############################################################################
ASCII_DOPPELPUNKT:
	ldi temp,':'
	rjmp ASCII_TEMP
; ##############################################################################
ASCII_KOMMA:
	ldi temp,','
	rjmp ASCII_TEMP
; ##############################################################################
ASCII_GRD:
	ldi temp,0x07
	rjmp ASCII_TEMP
; ##############################################################################
ASCII_PLUS:
	ldi temp,'+'
	rjmp ASCII_TEMP
; ##############################################################################
ASCII_MINUS2:
	ldi temp,'-'
	rcall ASCII_TEMP
ASCII_MINUS:
	ldi temp,'-'
	rjmp ASCII_TEMP
; ##############################################################################
ASCII_UNTERSTRICH2:
	ldi temp,'-'
	rcall ASCII_TEMP
ASCII_UNTERSTRICH:
	ldi temp,'-'
	rjmp ASCII_TEMP
; ##############################################################################
ASCII_SCHRAEGSTRICH:
	ldi temp,'/'
	rjmp ASCII_TEMP
; ##############################################################################
ASCII_FRAGEZEICHEN:
	ldi temp,'?'
	rjmp ASCII_TEMP
; ##############################################################################
ASCII_PROZENT:
	ldi temp,'%'
	rjmp ASCII_TEMP
; ##############################################################################
ASCII_V:
	ldi temp,'V'
	rjmp ASCII_TEMP
; ##############################################################################
ASCII_h_:
	ldi temp,'h'
	rjmp ASCII_TEMP
; ##############################################################################
ASCII_ms:
	ldi temp,'m'
	rcall ASCII_TEMP
	ldi temp,'s'
	rjmp ASCII_TEMP
; ##############################################################################
; ##############################################################################
; ##############################################################################
FONT:
  .db 0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff;0
  .db 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00;1
  .db 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00;2
  .db 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00;3
  .db 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00;4
  .db 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00;5
  .db 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00;6
  .db 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00;7
  .db 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00;8
  .db 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00;9
  .db 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00;10
  .db 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00;11
  .db 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00;12
  .db 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00;13
  .db 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00;14
  .db 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00;15
  .db 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00;16
  .db 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00;17
  .db 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00;18
  .db 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00;19
  .db 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00;20
  .db 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00;21
  .db 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00;22
  .db 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00;23
  .db 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00;24
  .db 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00;25
  .db 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00;26
  .db 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00;27
  .db 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00;28
  .db 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00;29
  .db 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00;30
  .db 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00;31
  .db 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00;	 	32 = 'space	'
  .db 0x00,0x00,0x00,0xfa,0xfa,0x00,0x00,0x00;	 	33 = '!'
  .db 0x00,0xe0,0xe0,0x00,0xe0,0xe0,0x00,0x00;	 	34 = '"'
  .db 0x28,0xfe,0xfe,0x28,0xfe,0xfe,0x28,0x00;	 	35 = '#'
  .db 0x00,0x24,0x54,0xfe,0xfe,0x54,0x48,0x00;	 	36 = '$'
  .db 0x00,0x62,0x66,0x0c,0x18,0x30,0x66,0x46;	 	37 = '%'
  .db 0x00,0x0c,0x5e,0xf2,0xba,0xec,0x5e,0x12;	 	38 = '&'
  .db 0x00,0x00,0x20,0xe0,0xc0,0x00,0x00,0x00;	 	39 = '''
  .db 0x00,0x00,0x38,0x7c,0xc6,0x82,0x00,0x00;	 	40 = '('
  .db 0x00,0x00,0x82,0xc6,0x7c,0x38,0x00,0x00;	 	41 = ')'
  .db 0x10,0x54,0x7c,0x38,0x38,0x7c,0x54,0x10;	 	42 = '*'
  .db 0x00,0x10,0x10,0x7c,0x7c,0x10,0x10,0x00;	 	43 = '+'
  .db 0x00,0x00,0x00,0x06,0x06,0x00,0x00,0x00;	 	44 = ','
  .db 0x00,0x10,0x10,0x10,0x10,0x10,0x10,0x00;	 	45 = '-'
  .db 0x00,0x00,0x00,0x06,0x06,0x00,0x00,0x00;	 	46 = '.'
  .db 0x06,0x0c,0x18,0x30,0x60,0xc0,0x80,0x00;	 	47 = '/'
  .db 0x7c,0xfe,0x8a,0x92,0xa2,0xfe,0x7c,0x00;	 	48 = '0'
  .db 0x00,0x00,0x40,0xfe,0xfe,0x00,0x00,0x00;	 	49 = '1'
  .db 0x00,0x42,0xc6,0x8e,0x9a,0xf2,0x62,0x00;	 	50 = '2'
  .db 0x00,0x44,0xc6,0x92,0x92,0xfe,0x6c,0x00;	 	51 = '3'
  .db 0x18,0x38,0x68,0xc8,0xfe,0xfe,0x08,0x00;	 	52 = '4'
  .db 0x00,0xe4,0xe6,0xa2,0xa2,0xbe,0x9c,0x00;	 	53 = '5'
  .db 0x00,0x7c,0xfe,0x92,0x92,0xde,0x4c,0x00;	 	54 = '6'
  .db 0x00,0x80,0x80,0x8e,0x9e,0xf0,0xe0,0x00;	 	55 = '7'
  .db 0x00,0x6c,0xfe,0x92,0x92,0xfe,0x6c,0x00;	 	56 = '8'
  .db 0x00,0x60,0xf2,0x96,0x9c,0xf8,0x70,0x00;	 	57 = '9'
  .db 0x00,0x00,0x00,0x36,0x36,0x00,0x00,0x00;	 	58 = ':'
  .db 0x00,0x00,0x80,0xb6,0x36,0x00,0x00,0x00;	 	59 = ';'
  .db 0x00,0x10,0x38,0x6c,0xc6,0x82,0x00,0x00;	 	60 = '<'
  .db 0x00,0x24,0x24,0x24,0x24,0x24,0x24,0x00;	 	61 = '='
  .db 0x00,0x82,0xc6,0x6c,0x38,0x10,0x00,0x00;	 	62 = '>'
  .db 0x00,0x40,0xc0,0x8a,0x9a,0xf0,0x60,0x00;	 	63 = '?'
  .db 0x7c,0xfe,0x82,0xba,0xba,0xfa,0x78,0x00;	 	64 = '@'
  .db 0x3e,0x7e,0xc8,0x88,0xc8,0x7e,0x3e,0x00;	 	65 = 'A'
  .db 0xfe,0xfe,0x92,0x92,0x92,0xfe,0x6c,0x00;	 	66 = 'B'
  .db 0x38,0x7c,0xc6,0x82,0x82,0xc6,0x44,0x00;	 	67 = 'C'
  .db 0xfe,0xfe,0x82,0x82,0xc6,0x7c,0x38,0x00;	 	68 = 'D'
  .db 0xfe,0xfe,0x92,0x92,0x92,0x82,0x82,0x00;	 	69 = 'E'
  .db 0xfe,0xfe,0x90,0x90,0x90,0x80,0x80,0x00;	 	70 = 'F'
  .db 0x38,0x7c,0xc6,0x82,0x8a,0xce,0x4e,0x00;	 	71 = 'G'
  .db 0xfe,0xfe,0x10,0x10,0x10,0xfe,0xfe,0x00;	 	72 = 'H'
  .db 0x00,0x82,0xfe,0xfe,0x82,0x00,0x00,0x00;	 	73 = 'I'
  .db 0x0c,0x0e,0x02,0x02,0x02,0xfe,0xfc,0x00;	 	74 = 'J'
  .db 0xfe,0xfe,0x90,0xb8,0x6c,0xc6,0x82,0x00;	 	75 = 'K'
  .db 0xfe,0xfe,0x02,0x02,0x02,0x02,0x02,0x00;	 	76 = 'L'
  .db 0xfe,0xfe,0x60,0x30,0x60,0xfe,0xfe,0x00;	 	77 = 'M'
  .db 0xfe,0xfe,0x60,0x30,0x18,0xfe,0xfe,0x00;	 	78 = 'N'
  .db 0x38,0x7c,0xc6,0x82,0xc6,0x7c,0x38,0x00;	 	79 = 'O'
  .db 0xfe,0xfe,0x90,0x90,0x90,0xf0,0x60,0x00;	 	80 = 'P'
  .db 0x38,0x7c,0xc6,0x8a,0xcc,0x76,0x3a,0x00;	 	81 = 'Q'
  .db 0xfe,0xfe,0x90,0x90,0x98,0xfe,0x66,0x00;	 	82 = 'R'
  .db 0x64,0xf6,0x92,0x92,0x92,0xde,0x4c,0x00;	 	83 = 'S'
  .db 0x80,0x80,0xfe,0xfe,0x80,0x80,0x00,0x00;	 	84 = 'T'
  .db 0xfc,0xfe,0x02,0x02,0x02,0xfe,0xfc,0x00;	 	85 = 'U'
  .db 0xf8,0xfc,0x06,0x02,0x06,0xfc,0xf8,0x00;	 	86 = 'V'
  .db 0xfe,0xfe,0x0c,0x18,0x0c,0xfe,0xfe,0x00;	 	87 = 'W'
  .db 0xc6,0xee,0x38,0x10,0x38,0xee,0xc6,0x00;	 	88 = 'X'
  .db 0x00,0xe0,0xf0,0x1e,0x1e,0xf0,0xe0,0x00;	 	89 = 'Y'
  .db 0x82,0x86,0x8e,0x9a,0xb2,0xe2,0xc2,0x00;	 	90 = 'Z'
  .db 0x00,0x00,0xfe,0xfe,0x82,0x82,0x00,0x00;	 	91 = '['
  .db 0xFC,0x84,0xBF,0xA5,0xA5,0xFD,0x21,0x3F;	 	92 = '\' => OO = Stereo Symbol
  .db 0x00,0x00,0x82,0x82,0xfe,0xfe,0x00,0x00;	 	93 = ']'
  .db 0x00,0x10,0x30,0x60,0xc0,0x60,0x30,0x10;	 	94 = '^'
  .db 0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01;	 	95 = '_'
  .db 0x00,0x00,0x80,0xc0,0x60,0x20,0x00,0x00;	 	96 = '''
  .db 0x04,0x2e,0x2a,0x2a,0x2a,0x3e,0x1e,0x00;	 	97 = 'a'
  .db 0xfe,0xfe,0x22,0x22,0x22,0x3e,0x1c,0x00;	 	98 = 'b'
  .db 0x1c,0x3e,0x22,0x22,0x22,0x36,0x14,0x00;	 	99 = 'c'
  .db 0x1c,0x3e,0x22,0x22,0x22,0xfe,0xfe,0x00;	 	100	= 'd'
  .db 0x1c,0x3e,0x2a,0x2a,0x2a,0x3a,0x18,0x00;	 	101	= 'e'
  .db 0x10,0x7e,0xfe,0x90,0x90,0xc0,0x40,0x00;	 	102	= 'f'
  .db 0x19,0x3d,0x25,0x25,0x25,0x3f,0x3e,0x00;	 	103	= 'g'
  .db 0xfe,0xfe,0x20,0x20,0x20,0x3e,0x1e,0x00;	 	104	= 'h'
  .db 0x00,0x00,0x00,0xbe,0xbe,0x00,0x00,0x00;	 	105	= 'i'
  .db 0x02,0x03,0x01,0x01,0xbf,0xbe,0x00,0x00;	 	106	= 'j'
  .db 0xfe,0xfe,0x08,0x08,0x1c,0x36,0x22,0x00;	 	107	= 'k'
  .db 0x00,0x00,0x00,0xfe,0xfe,0x00,0x00,0x00;	 	108	= 'l'
  .db 0x1e,0x3e,0x30,0x18,0x30,0x3e,0x1e,0x00;	 	109	= 'm'
  .db 0x3e,0x3e,0x20,0x20,0x20,0x3e,0x1e,0x00;	 	110	= 'n'
  .db 0x1c,0x3e,0x22,0x22,0x22,0x3e,0x1c,0x00;	 	111	= 'o'
  .db 0x3f,0x3f,0x24,0x24,0x24,0x3c,0x18,0x00;	 	112	= 'p'
  .db 0x18,0x3c,0x24,0x24,0x24,0x3f,0x3f,0x00;	 	113	= 'q'
  .db 0x3e,0x3e,0x20,0x20,0x20,0x30,0x10,0x00;	 	114	= 'r'
  .db 0x12,0x3a,0x2a,0x2a,0x2a,0x2e,0x04,0x00;	 	115	= 's'
  .db 0x20,0xfc,0xfe,0x22,0x22,0x26,0x04,0x00;	 	116	= 't'
  .db 0x3c,0x3e,0x02,0x02,0x02,0x3e,0x3e,0x00;	 	117	= 'u'
  .db 0x38,0x3c,0x06,0x02,0x06,0x3c,0x38,0x00;	 	118	= 'v'
  .db 0x3c,0x3e,0x06,0x0c,0x06,0x3e,0x3c,0x00;	 	119	= 'w'
  .db 0x22,0x36,0x1c,0x08,0x1c,0x36,0x22,0x00;	 	120	= 'x'
  .db 0x39,0x3d,0x05,0x05,0x05,0x3f,0x3e,0x00;	 	121	= 'y'
  .db 0x00,0x22,0x26,0x2e,0x3a,0x32,0x22,0x00;		122 = 'z'
