; ##############################################################################
; ##############################################################################
; ##############################################################################
; Version 10/2017																
;																				
; Ein Byte aus EEPROM holen und Z-Zeiger + 1									
;																				
; INPUT:	ZL Adresse (low)													
;			ZH Adresse (High)													
;																				
; OUTPUT: 	temp (DATEN)														
;																				
EEPROM_READ_PLUS_Z_TEMP:
	sbic EECR,EEWE 		; Wait for completion of previous write
	rjmp EEPROM_READ_PLUS_Z_TEMP
	out  EEARH, ZH		; ADRESSE setzen						
	out  EEARL, ZL
	sbi  EECR,EERE		; Start eeprom read by writing EERE		
	in 	 temp,EEDR		; Read data from data register			
	adiw ZL,1			; ADRESSE +1 							
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Version 10/2017																
;																				
; Ein Byte im EEPROM ablegen und Z-Zeiger + 1									
;																				
; INPUT:	ZL Adresse (low)													
;			ZH Adresse (High)													
; 		 	temp  DATEN															
;																				
EEPROM_WRITE_PLUS_Z_TEMP:
	sbic EECR,EEWE		; Wait for completion of previous write
	rjmp EEPROM_WRITE_PLUS_Z_TEMP
	out  EEARH,ZH		; ADRESSE setzen						
	out  EEARL,ZL
	out  EEDR, temp		; Write data  to data register			
	sbi  EECR, EEMWE	; Write logical one to EEMWE			
	sbi  EECR, EEWE		; Start eeprom write by setting EEWE	
	adiw ZL,1			; Z+1									

	rcall ASCII_PUNKT
	rcall WAIT_10ms
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
EEPROM_LOAD:
.equ ANZAHL_EEPROM_BYTES			=10
;-------------------------------------------------------------------------------
; Anzeige Version																
	clr ZL
	clr ZH
	rcall EEPROM_READ_PLUS_Z_TEMP
	mov temp1,temp
	rcall ZAHL_TEMP1
	rcall WAIT_100ms
;-------------------------------------------------------------------------------
; Version																		
	clr ZL
	clr ZH
	rcall EEPROM_READ_PLUS_Z_TEMP
	cpi temp,(VERSION)
	breq EEPROM_START
	mov temp1,temp
	rcall ZAHL_TEMP1
	LED_ROT_ON
	rcall EEPROM_SAVE
	rcall WAIT_1s
	rcall WAIT_1s
	rcall WAIT_1s
EEPROM_LOAD_s:
	rjmp EEPROM_LOAD_s
;-------------------------------------------------------------------------------
EEPROM_START:
	ldi XL, LOW (adr_DATEN)
	ldi XH, HIGH(adr_DATEN)
	clr ZL
	clr ZH
;-------------------------------------------------------------------------------
	ldi temp9,(ANZAHL_EEPROM_BYTES)
EEPROM_KONFIGURATION_LADEN_s:
	rcall EEPROM_READ_PLUS_Z_TEMP
	ST X+,temp
	dec temp9
	brne EEPROM_KONFIGURATION_LADEN_s
	rcall WAIT_500ms
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
EEPROM_SAVE:
	ldi XL, LOW (adr_DATEN)
	ldi XH, HIGH(adr_DATEN)
	clr ZL
	clr ZH
;-------------------------------------------------------------------------------
	ldi temp9,(ANZAHL_EEPROM_BYTES)
EEPROM_KONFIGURATION_SPEICHERN_s:
	LD temp,X+
	rcall EEPROM_WRITE_PLUS_Z_TEMP
	dec temp9
	brne EEPROM_KONFIGURATION_SPEICHERN_s
	rcall WAIT_500ms
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################

