; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_START:
	STS(adr_MENUE),EINS	; !
	LED_GRUEN_OFF
	LED_GELB_OFF
	LED_ROT_OFF
	rcall LCD_CLEAR
	rcall WAIT_100ms
;-------------------------------------------------------------------------------
MENUE_VIEW:
	rcall MENUE
	LDS temp,(adr_MENUE_TIMER)	
	tst temp
	brne MENUE_VIEW
;-------------------------------------------------------------------------------
	rcall EEPROM_SAVE
	rjmp PROGRAMM_NEUSTART
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE:
	rcall ZEILE1
	rcall WAIT_200ms
	ldi temp9,100
MENUE_TASTE_s:
	STS(adr_TASTE),NULL 
	rcall WAIT_1ms
	LDS temp,(adr_TASTE)
	tst temp
	brne MENUE_TASTE_FERTIG
	dec temp9
	brne MENUE_TASTE_s
MENUE_TASTE_FERTIG:
;-------------------------------------------------------------------------------
	tst temp
	breq MENUE_w1
	push temp
	rcall LCD_CLEAR
	rcall WAIT_100ms
	pop temp
MENUE_w1:
	cpi temp,1
	brne MENUE_RUN
;-------------------------------------------------------------------------------
	LDS temp,(adr_MENUE)
	inc temp
	STS(adr_MENUE),temp
;-------------------------------------------------------------------------------
MENUE_RUN:
	ldi ZL,LOW (MENUE_SPRUNGMARKE)	; Z initialisieren	
	ldi ZH,HIGH(MENUE_SPRUNGMARKE)
	LDS temp,(adr_MENUE)
	add ZL,temp 
	adc ZH,NULL
	ijmp			; SPRUNG nach Z		
;-------------------------------------------------------------------------------
MENUE_SPRUNGMARKE:
	nop 				; DUMMY
	rjmp TEXT_SYSTEM
	rjmp MENUE_EDIT_ZEIT_MIKROSTEP
	rjmp MENUE_MOTOR_TEST
	rjmp MENUE_SYSTEM_INFO
	rjmp MENUE_WERK
	rjmp MENUE_BAUSTELLE
	STS(adr_MENUE),EINS	; !
	rjmp MENUE
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_BAUSTELLE:
	rcall TEXT_BAUSTELLE
	rcall ZEILE2
	LDS temp1,(adr_MENUE)
	rcall ZAHL_TEMP1
	LDS temp1,(adr_TASTE)
	rcall ZAHL_TEMP1
	LDS temp1,(adr_MENUE_TIMER)
	rcall ZAHL_TEMP1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_SYSTEM_INFO:
	rcall ASCII_S
	rcall ASCII_p_
	rcall ASCII_V
	ldi temp1,(STEPS_PRO_VOLLSCHRITT)
	rcall ZAHL_TEMP1

	rcall ASCII_V
	rcall ASCII_p_
	rcall ASCII_U
	ldi temp1,(VOLLSCHRITTE_PRO_UMDREHUNG)
	rcall ZAHL_TEMP1


	rcall ZEILE2
	rcall TEXT_WAIT
	LDS temp1,(adr_SINUS_COSINUS_WAIT)
	rcall ZAHL_TEMP1
	rcall ASCII_m_
	rcall ASCII_s_
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_MOTOR_TEST:
	rcall TEXT_MOTOR
	rcall TEXT_TEST
	rcall ASCII_1
	rcall ASCII_X_
	rcall ASCII_U
	LDS temp,(adr_TASTE)
	cpi temp,(TASTE_B)
	breq MENUE_MOTOR_TEST_RUN
	ret
;-------------------------------------------------------------------------------
MENUE_MOTOR_TEST_RUN:
	STS(adr_TURBO),EINS
	rcall MOTOR_SPEED_TEST
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_EDIT_ZEIT_MIKROSTEP:
	rcall ASCII_SPACE
	rcall TEXT_EDIT
	rcall TEXT_MIKROSTEP
	rcall ZEILE2
	LDS temp1,(adr_ZEIT_MIKROSTEP_L)
	LDS temp2,(adr_ZEIT_MIKROSTEP_H)
	rcall ZAHL_KOMMA_TEMP1_2
	rcall ASCII_m_
	rcall ASCII_s_
	LDS temp,(adr_TASTE)
	cpi temp,(TASTE_B)
	breq MENUE_EDIT_ZEIT_MIKROSTEP_RUN
	ret
;-------------------------------------------------------------------------------
MENUE_EDIT_ZEIT_MIKROSTEP_RUN:
	rcall LCD_CLEAR
	rcall ZEILE1
	LDS temp1,(adr_ZEIT_MIKROSTEP_L)
	LDS temp2,(adr_ZEIT_MIKROSTEP_H)
	rcall ZAHL_KOMMA_TEMP1_2
	rcall ASCII_m_
	rcall ASCII_s_

	rcall ZEILE2
	ldi temp1, low(ZEIT_MIKROSTEP)
	ldi temp2,high(ZEIT_MIKROSTEP)
	rcall ZAHL_KOMMA_TEMP1_2
	rcall ASCII_m_
	rcall ASCII_s_

	STS(adr_TASTE),NULL 	
	rcall WAIT_200ms
	LDS temp,(adr_TASTE)
	cpi temp,(TASTE_A)
	breq MENUE_EDIT_ZEIT_A
	cpi temp,(TASTE_B)
	breq MENUE_EDIT_ZEIT_B

	LDS temp,(adr_MENUE_TIMER)
	tst temp
	brne MENUE_EDIT_ZEIT_MIKROSTEP_RUN
	ret
;-------------------------------------------------------------------------------
MENUE_EDIT_ZEIT_A:
	LDS temp1,(adr_ZEIT_MIKROSTEP_L)
	LDS temp2,(adr_ZEIT_MIKROSTEP_H)
	sub temp1,EINS
	sbc temp2,NULL
	STS(adr_ZEIT_MIKROSTEP_L),temp1
	STS(adr_ZEIT_MIKROSTEP_H),temp2
	rjmp MENUE_EDIT_ZEIT_MIKROSTEP_RUN
;-------------------------------------------------------------------------------
MENUE_EDIT_ZEIT_B:
	LDS temp1,(adr_ZEIT_MIKROSTEP_L)
	LDS temp2,(adr_ZEIT_MIKROSTEP_H)
	add temp1,EINS
	adc temp2,NULL
	STS(adr_ZEIT_MIKROSTEP_L),temp1
	STS(adr_ZEIT_MIKROSTEP_H),temp2
	rjmp MENUE_EDIT_ZEIT_MIKROSTEP_RUN
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_WERK:
	rcall TEXT_WERK
	LDS temp,(adr_TASTE)
	cpi temp,(TASTE_B)
	breq MENUE_WERK_RUN
	ret
;-------------------------------------------------------------------------------
MENUE_WERK_RUN:
	STS(adr_VERSION),NULL
	rcall EEPROM_SAVE
	rjmp PROGRAMM_NEUSTART
; ##############################################################################
; ##############################################################################
; ##############################################################################
