; ##############################################################################
; ##############################################################################
; ##############################################################################
MOTOR_MIKROSTEP:
	LDS temp1,(adr_POSITION_IST_0)
	LDS temp2,(adr_POSITION_IST_1)
	LDS temp3,(adr_POSITION_IST_2)
	add temp1,EINS
	adc temp2,NULL
	adc temp3,NULL
	STS(adr_POSITION_IST_0),temp1
	STS(adr_POSITION_IST_1),temp2
	STS(adr_POSITION_IST_2),temp3
;-------------------------------------------------------------------------------
	LDS XL,(adr_DREHFELD_L)			; 0...1399 (0...360x4-1)	
	LDS XH,(adr_DREHFELD_H)
	adiw XL,1
	cpi XH,high(360*4-1)				; Vergleich	
	breq MOTOR_MIKROSTEP_L
	brsh MOTOR_MIKROSTEP_NULL
	brlo MOTOR_STEP_RUN
MOTOR_MIKROSTEP_L:
	cpi XL,low (360*4-1)
	breq MOTOR_STEP_RUN
	brsh MOTOR_MIKROSTEP_NULL
	brlo MOTOR_STEP_RUN
MOTOR_MIKROSTEP_NULL:
	clr XL
	clr XH
;-------------------------------------------------------------------------------
MOTOR_STEP_RUN:
	STS(adr_DREHFELD_L),XL			; SAVE		
	STS(adr_DREHFELD_H),XH
;-------------------------------------------------------------------------------
	rcall SINUS_X_TEMP1_2			; out: 0...1023 
	mov R0,temp1
	mov R1,temp2
;-------------------------------------------------------------------------------
	rcall COSINUS_X_TEMP1_2			; out: 0...1023	
	out PWM_A_H,R1				; PWM zuerst H	
	out PWM_A_L,R0				; PWM dann   L	
	out PWM_B_H,temp2				; PWM zuerst H	
	out PWM_B_L,temp1				; PWM dann   L	
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
SINUS_X_TEMP1_2:
	ldi ZL,low (TABELLE_SINUS*2)
	ldi ZH,high(TABELLE_SINUS*2)
	LSL	XL			; X x2 (Datensatzlnge)		
	ROL XH 
	add ZL,XL		; Z auf Tabellendatensatz	
	adc ZH,XH
	LPM temp1,Z+
	LPM temp2,Z+
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
COSINUS_X_TEMP1_2:
	sbiw ZL,2		; Z wieder auf Tabellendatensatz	
	ldi temp1,low (90*4*2)
	ldi temp2,high(90*4*2)
	add ZL,temp1
	adc ZH,temp2
	LPM temp1,Z+
	LPM temp2,Z+
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MOTOR_INITIALISIERUNG:
;-------------------------------------------------------------------------------
; bersezung mal MikrostepProStep												
	LDS temp1,(adr_GERTRIEBE_L)
	LDS temp2,(adr_GERTRIEBE_H)
	ldi temp3,low (MIKROSTEPS_PRO_STEP)
	ldi temp4,high(MIKROSTEPS_PRO_STEP)
	rcall MULTIPLIKATION_16_16
	mov R0,temp1
	mov R1,temp2
	mov R2,temp3
	mov R3,temp4
;-------------------------------------------------------------------------------
; mal MotorSteps																
	ldi temp9,(MOTOR_STEPS-1)
MOTOR_INITIALISIERUNG_s:
	add temp1,R0
	adc temp2,R1
	adc temp3,R2
	adc temp4,R3
	dec temp9
	brne MOTOR_INITIALISIERUNG_s
;-------------------------------------------------------------------------------
; durch 4																		
	LSR temp4	; durch 2
	ROR temp3
	ROR temp2
	ROR temp1
	LSR temp4	; durch 2
	ROR temp3
	ROR temp2
	ROR temp1
;-------------------------------------------------------------------------------
; DURCH 42190																	
	ldi temp5,low (42190)
	ldi temp6,high(42190)
	rcall DIVISION_32_16
	STS(adr_KONSTANTE_L),temp1
	STS(adr_KONSTANTE_H),temp2
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; SIN auf 511, COS auf 1022														
MOTOR_SANFTANLAUF:
	in temp1,PWM_A_L
	in temp2,PWM_A_H
	cpi temp1, low(512)
	brne MOTOR_SANFTANLAUF_SIN_K
	cpi temp2,high(512)
	brne MOTOR_SANFTANLAUF_SIN_K
	rjmp MOTOR_SANFTANLAUF_COS
;-------------------------------------------------------------------------------
MOTOR_SANFTANLAUF_SIN_K:
	add temp1,EINS
	adc temp2,NULL
	out PWM_A_H,temp2				; PWM zuerst H	
	out PWM_A_L,temp1				; PWM dann   L	
	rcall WAIT_1ms					; PAUSE			
	rjmp MOTOR_SANFTANLAUF
;-------------------------------------------------------------------------------
MOTOR_SANFTANLAUF_COS:
	in temp1,PWM_B_L
	in temp2,PWM_B_H
	cpi temp1, low(1022)
	brne MOTOR_SANFTANLAUF_COS_K
	cpi temp2,high(1022)
	brne MOTOR_SANFTANLAUF_COS_K
	ret
;-------------------------------------------------------------------------------
MOTOR_SANFTANLAUF_COS_K:
	add temp1,EINS
	adc temp2,NULL
	out PWM_B_H,temp2				; PWM zuerst H	
	out PWM_B_L,temp1				; PWM dann   L	
	rcall WAIT_1ms					; PAUSE			
	rjmp MOTOR_SANFTANLAUF_COS
; ##############################################################################
; ##############################################################################
; ##############################################################################
;	1	2	3	4	5	6	7	8												
;1	-	-		+	+	+		-												
;2	+	+		-	-	-		+												
;3		-	-	-		+	+	+												
;4		+	+	+		-	-	-												
; Motor im Vollstepbetrieb, ohne PWM											
MOTOR_TEST_HART:
	rcall UHR_NULL

	ldi temp1,BYTE1(372960)
	ldi temp2,BYTE2(372960)
	ldi temp3,BYTE3(372960)
MOTOR_TEST_HART_s1:
	push temp1
	push temp2
	push temp3
	WDR
	rcall MOTOR_MIKROSTEP
;	rcall WAIT_100us
	pop temp3
	pop temp2
	pop temp1
	sub temp1,EINS
	sbc temp2,NULL
	sbc temp3,NULL
	tst temp1	
	brne MOTOR_TEST_HART_s1
	tst temp2	
	brne MOTOR_TEST_HART_s1
	tst temp3	
	brne MOTOR_TEST_HART_s1

	rcall ANZEIGE_HAUPT
	rcall WAIT_2s
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; OUT: 0...511...+1022, 0,5 Grad Schritte										
TABELLE_SINUS:
.dw 511,513,515,518,520,522,524,527,529,531;0-2,25
.dw 533,536,538,540,542,544,547,549,551,553;2,5-4,75
.dw 556,558,560,562,564,567,569,571,573,575;5-7,25
.dw 578,580,582,584,587,589,591,593,595,598;7,5-9,75
.dw 600,602,604,606,609,611,613,615,617,619;10-12,25
.dw 622,624,626,628,630,632,635,637,639,641;12,5-14,75
.dw 643,645,648,650,652,654,656,658,660,663;15-17,25
.dw 665,667,669,671,673,675,677,679,682,684;17,5-19,75
.dw 686,688,690,692,694,696,698,700,702,704;20-22,25
.dw 707,709,711,713,715,717,719,721,723,725;22,5-24,75
.dw 727,729,731,733,735,737,739,741,743,745;25-27,25
.dw 747,749,751,753,755,757,759,761,763,765;27,5-29,75
.dw 767,768,770,772,774,776,778,780,782,784;30-32,25
.dw 786,787,789,791,793,795,797,799,800,802;32,5-34,75
.dw 804,806,808,810,811,813,815,817,819,820;35-37,25
.dw 822,824,826,827,829,831,833,834,836,838;37,5-39,75
.dw 839,841,843,845,846,848,850,851,853,855;40-42,25
.dw 856,858,860,861,863,864,866,868,869,871;42,5-44,75
.dw 872,874,875,877,879,880,882,883,885,886;45-47,25
.dw 888,889,891,892,894,895,897,898,900,901;47,5-49,75
.dw 902,904,905,907,908,910,911,912,914,915;50-52,25
.dw 916,918,919,920,922,923,924,926,927,928;52,5-54,75
.dw 930,931,932,933,935,936,937,938,940,941;55-57,25
.dw 942,943,944,946,947,948,949,950,951,952;57,5-59,75
.dw 954,955,956,957,958,959,960,961,962,963;60-62,25
.dw 964,965,966,967,968,969,970,971,972,973;62,5-64,75
.dw 974,975,976,977,978,979,980,981,981,982;65-67,25
.dw 983,984,985,986,986,987,988,989,990,990;67,5-69,75
.dw 991,992,993,993,994,995,996,996,997,998;70-72,25
.dw 998,999,1000,1000,1001,1002,1002,1003,1003,1004;72,5-74,75
.dw 1005,1005,1006,1006,1007,1007,1008,1008,1009,1009;75-77,25
.dw 1010,1010,1011,1011,1012,1012,1013,1013,1013,1014;77,5-79,75
.dw 1014,1015,1015,1015,1016,1016,1016,1017,1017,1017;80-82,25
.dw 1018,1018,1018,1018,1019,1019,1019,1019,1020,1020;82,5-84,75
.dw 1020,1020,1020,1021,1021,1021,1021,1021,1021,1021;85-87,25
.dw 1022,1022,1022,1022,1022,1022,1022,1022,1022,1022;87,5-89,75
.dw 1022,1022,1022,1022,1022,1022,1022,1022,1022,1022;90-92,25
.dw 1022,1021,1021,1021,1021,1021,1021,1021,1020,1020;92,5-94,75
.dw 1020,1020,1020,1019,1019,1019,1019,1018,1018,1018;95-97,25
.dw 1018,1017,1017,1017,1016,1016,1016,1015,1015,1015;97,5-99,75
.dw 1014,1014,1013,1013,1013,1012,1012,1011,1011,1010;100-102,25
.dw 1010,1009,1009,1008,1008,1007,1007,1006,1006,1005;102,5-104,75
.dw 1005,1004,1003,1003,1002,1002,1001,1000,1000,999;105-107,25
.dw 998,998,997,996,996,995,994,993,993,992;107,5-109,75
.dw 991,990,990,989,988,987,986,986,985,984;110-112,25
.dw 983,982,981,981,980,979,978,977,976,975;112,5-114,75
.dw 974,973,972,971,970,969,968,967,966,965;115-117,25
.dw 964,963,962,961,960,959,958,957,956,955;117,5-119,75
.dw 954,952,951,950,949,948,947,946,944,943;120-122,25
.dw 942,941,940,938,937,936,935,933,932,931;122,5-124,75
.dw 930,928,927,926,924,923,922,920,919,918;125-127,25
.dw 916,915,914,912,911,910,908,907,905,904;127,5-129,75
.dw 902,901,900,898,897,895,894,892,891,889;130-132,25
.dw 888,886,885,883,882,880,879,877,875,874;132,5-134,75
.dw 872,871,869,868,866,864,863,861,860,858;135-137,25
.dw 856,855,853,851,850,848,846,845,843,841;137,5-139,75
.dw 839,838,836,834,833,831,829,827,826,824;140-142,25
.dw 822,820,819,817,815,813,811,810,808,806;142,5-144,75
.dw 804,802,800,799,797,795,793,791,789,787;145-147,25
.dw 786,784,782,780,778,776,774,772,770,768;147,5-149,75
.dw 767,765,763,761,759,757,755,753,751,749;150-152,25
.dw 747,745,743,741,739,737,735,733,731,729;152,5-154,75
.dw 727,725,723,721,719,717,715,713,711,709;155-157,25
.dw 707,704,702,700,698,696,694,692,690,688;157,5-159,75
.dw 686,684,682,679,677,675,673,671,669,667;160-162,25
.dw 665,663,660,658,656,654,652,650,648,645;162,5-164,75
.dw 643,641,639,637,635,632,630,628,626,624;165-167,25
.dw 622,619,617,615,613,611,609,606,604,602;167,5-169,75
.dw 600,598,595,593,591,589,587,584,582,580;170-172,25
.dw 578,575,573,571,569,567,564,562,560,558;172,5-174,75
.dw 556,553,551,549,547,544,542,540,538,536;175-177,25
.dw 533,531,529,527,524,522,520,518,515,513;177,5-179,75
.dw 511,509,507,504,502,500,498,495,493,491;180-182,25
.dw 489,486,484,482,480,478,475,473,471,469;182,5-184,75
.dw 466,464,462,460,458,455,453,451,449,447;185-187,25
.dw 444,442,440,438,435,433,431,429,427,424;187,5-189,75
.dw 422,420,418,416,413,411,409,407,405,403;190-192,25
.dw 400,398,396,394,392,390,387,385,383,381;192,5-194,75
.dw 379,377,374,372,370,368,366,364,362,359;195-197,25
.dw 357,355,353,351,349,347,345,343,340,338;197,5-199,75
.dw 336,334,332,330,328,326,324,322,320,318;200-202,25
.dw 315,313,311,309,307,305,303,301,299,297;202,5-204,75
.dw 295,293,291,289,287,285,283,281,279,277;205-207,25
.dw 275,273,271,269,267,265,263,261,259,257;207,5-209,75
.dw 256,254,252,250,248,246,244,242,240,238;210-212,25
.dw 236,235,233,231,229,227,225,223,222,220;212,5-214,75
.dw 218,216,214,212,211,209,207,205,203,202;215-217,25
.dw 200,198,196,195,193,191,189,188,186,184;217,5-219,75
.dw 183,181,179,177,176,174,172,171,169,167;220-222,25
.dw 166,164,162,161,159,158,156,154,153,151;222,5-224,75
.dw 150,148,147,145,143,142,140,139,137,136;225-227,25
.dw 134,133,131,130,128,127,125,124,122,121;227,5-229,75
.dw 120,118,117,115,114,112,111,110,108,107;230-232,25
.dw 106,104,103,102,100,99,98,96,95,94;232,5-234,75
.dw 92,91,90,89,87,86,85,84,82,81;235-237,25
.dw 80,79,78,76,75,74,73,72,71,70;237,5-239,75
.dw 68,67,66,65,64,63,62,61,60,59;240-242,25
.dw 58,57,56,55,54,53,52,51,50,49;242,5-244,75
.dw 48,47,46,45,44,43,42,41,41,40;245-247,25
.dw 39,38,37,36,36,35,34,33,32,32;247,5-249,75
.dw 31,30,29,29,28,27,26,26,25,24;250-252,25
.dw 24,23,22,22,21,20,20,19,19,18;252,5-254,75
.dw 17,17,16,16,15,15,14,14,13,13;255-257,25
.dw 12,12,11,11,10,10,9,9,9,8;257,5-259,75
.dw 8,7,7,7,6,6,6,5,5,5;260-262,25
.dw 4,4,4,4,3,3,3,3,2,2;262,5-264,75
.dw 2,2,2,1,1,1,1,1,1,1;265-267,25
.dw 0,0,0,0,0,0,0,0,0,0;267,5-269,75
.dw 0,0,0,0,0,0,0,0,0,0;270-272,25
.dw 0,1,1,1,1,1,1,1,2,2;272,5-274,75
.dw 2,2,2,3,3,3,3,4,4,4;275-277,25
.dw 4,5,5,5,6,6,6,7,7,7;277,5-279,75
.dw 8,8,9,9,9,10,10,11,11,12;280-282,25
.dw 12,13,13,14,14,15,15,16,16,17;282,5-284,75
.dw 17,18,19,19,20,20,21,22,22,23;285-287,25
.dw 24,24,25,26,26,27,28,29,29,30;287,5-289,75
.dw 31,32,32,33,34,35,36,36,37,38;290-292,25
.dw 39,40,41,41,42,43,44,45,46,47;292,5-294,75
.dw 48,49,50,51,52,53,54,55,56,57;295-297,25
.dw 58,59,60,61,62,63,64,65,66,67;297,5-299,75
.dw 68,70,71,72,73,74,75,76,78,79;300-302,25
.dw 80,81,82,84,85,86,87,89,90,91;302,5-304,75
.dw 92,94,95,96,98,99,100,102,103,104;305-307,25
.dw 106,107,108,110,111,112,114,115,117,118;307,5-309,75
.dw 120,121,122,124,125,127,128,130,131,133;310-312,25
.dw 134,136,137,139,140,142,143,145,147,148;312,5-314,75
.dw 150,151,153,154,156,158,159,161,162,164;315-317,25
.dw 166,167,169,171,172,174,176,177,179,181;317,5-319,75
.dw 183,184,186,188,189,191,193,195,196,198;320-322,25
.dw 200,202,203,205,207,209,211,212,214,216;322,5-324,75
.dw 218,220,222,223,225,227,229,231,233,235;325-327,25
.dw 236,238,240,242,244,246,248,250,252,254;327,5-329,75
.dw 256,257,259,261,263,265,267,269,271,273;330-332,25
.dw 275,277,279,281,283,285,287,289,291,293;332,5-334,75
.dw 295,297,299,301,303,305,307,309,311,313;335-337,25
.dw 315,318,320,322,324,326,328,330,332,334;337,5-339,75
.dw 336,338,340,343,345,347,349,351,353,355;340-342,25
.dw 357,359,362,364,366,368,370,372,374,377;342,5-344,75
.dw 379,381,383,385,387,390,392,394,396,398;345-347,25
.dw 400,403,405,407,409,411,413,416,418,420;347,5-349,75
.dw 422,424,427,429,431,433,435,438,440,442;350-352,25
.dw 444,447,449,451,453,455,458,460,462,464;352,5-354,75
.dw 466,469,471,473,475,478,480,482,484,486;355-357,25
.dw 489,491,493,495,498,500,502,504,507,509;357,5-359,75
.dw 511,513,515,518,520,522,524,527,529,531;360-362,25
.dw 533,536,538,540,542,544,547,549,551,553;362,5-364,75
.dw 556,558,560,562,564,567,569,571,573,575;365-367,25
.dw 578,580,582,584,587,589,591,593,595,598;367,5-369,75
.dw 600,602,604,606,609,611,613,615,617,619;370-372,25
.dw 622,624,626,628,630,632,635,637,639,641;372,5-374,75
.dw 643,645,648,650,652,654,656,658,660,663;375-377,25
.dw 665,667,669,671,673,675,677,679,682,684;377,5-379,75
.dw 686,688,690,692,694,696,698,700,702,704;380-382,25
.dw 707,709,711,713,715,717,719,721,723,725;382,5-384,75
.dw 727,729,731,733,735,737,739,741,743,745;385-387,25
.dw 747,749,751,753,755,757,759,761,763,765;387,5-389,75
.dw 767,768,770,772,774,776,778,780,782,784;390-392,25
.dw 786,787,789,791,793,795,797,799,800,802;392,5-394,75
.dw 804,806,808,810,811,813,815,817,819,820;395-397,25
.dw 822,824,826,827,829,831,833,834,836,838;397,5-399,75
.dw 839,841,843,845,846,848,850,851,853,855;400-402,25
.dw 856,858,860,861,863,864,866,868,869,871;402,5-404,75
.dw 872,874,875,877,879,880,882,883,885,886;405-407,25
.dw 888,889,891,892,894,895,897,898,900,901;407,5-409,75
.dw 902,904,905,907,908,910,911,912,914,915;410-412,25
.dw 916,918,919,920,922,923,924,926,927,928;412,5-414,75
.dw 930,931,932,933,935,936,937,938,940,941;415-417,25
.dw 942,943,944,946,947,948,949,950,951,952;417,5-419,75
.dw 954,955,956,957,958,959,960,961,962,963;420-422,25
.dw 964,965,966,967,968,969,970,971,972,973;422,5-424,75
.dw 974,975,976,977,978,979,980,981,981,982;425-427,25
.dw 983,984,985,986,986,987,988,989,990,990;427,5-429,75
.dw 991,992,993,993,994,995,996,996,997,998;430-432,25
.dw 998,999,1000,1000,1001,1002,1002,1003,1003,1004;432,5-434,75
.dw 1005,1005,1006,1006,1007,1007,1008,1008,1009,1009;435-437,25
.dw 1010,1010,1011,1011,1012,1012,1013,1013,1013,1014;437,5-439,75
.dw 1014,1015,1015,1015,1016,1016,1016,1017,1017,1017;440-442,25
.dw 1018,1018,1018,1018,1019,1019,1019,1019,1020,1020;442,5-444,75
.dw 1020,1020,1020,1021,1021,1021,1021,1021,1021,1021;445-447,25
.dw 1022,1022,1022,1022,1022,1022,1022,1022,1022,1022;447,5-449,75
.dw 1022,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff;450 Error	






