; ##############################################################################
; ##############################################################################
; ##############################################################################
STARTWERTE:
	; NULL				
	clr NULL
	; EINS				
	ldi temp,1
	mov EINS,temp
	; VOLL				
	ldi temp,255
	mov VOLL,temp
	; VERSION			
	ldi temp,(VERSION)
	STS(adr_VERSION),temp
	; Zeit				
	ldi temp,1
	STS(adr_hh),temp
	ldi temp,0
	STS(adr_mm),temp
	ldi temp,0
	STS(adr_ss),temp
	; Getriebebersetzung
	ldi temp1,low (GETRIEBE)
	ldi temp2,high(GETRIEBE)
	STS(adr_GERTRIEBE_L),temp1
	STS(adr_GERTRIEBE_H),temp2
	; Drehfeld			
	ldi temp1,low (-1)
	ldi temp2,high(-1)
;	STS(adr_DREHFELD_L),temp1			; SAVE		
;	STS(adr_DREHFELD_H),temp2	
	; SRAM CHECK		
	ldi temp,'S'
	STS(adr_SRAM_CHECK),temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
PROGRAMM_CHECK:
	; NULL		
	tst NULL
	brne PROGRAMM_CHECK_ERROR
	; EINS		
	mov temp,EINS
	cpi temp,1
	brne PROGRAMM_CHECK_ERROR
	; SRAM CHECK
	LDS temp,(adr_SRAM_CHECK)
	cpi temp,'S'
	brne PROGRAMM_CHECK_ERROR
	ret
;-------------------------------------------------------------------------------
PROGRAMM_CHECK_ERROR:
	CLI 										; Global Interrupt Disable
	rcall wait_100ms
	LED_ROT_ON
	rcall wait_100ms
	LED_GRUEN_OFF
	LED_GELB_OFF
	LED_ROT_OFF
	rjmp PROGRAMM_CHECK_ERROR
; ##############################################################################
; ##############################################################################
; ##############################################################################
WDR_INITIALISIERUNG:
	ldi TEMP,(1<<WDCE)|(1<<WDE) ; Watchdog aktivieren (max. Zeit)				
	out wdtcr,TEMP       
	ldi TEMP,(1<<WDE) | (1<<WDP2)|(1<<WDP1)|(1<<WDP0) 
	out wdtcr,temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
SRAM_CLEAR:
	ldi ZL, LOW (SRAM_START)
	ldi ZH, HIGH(SRAM_START)
	ldi temp,0
;-------------------------------------------------------------------------------
SRAM_CLEAR_w:
	ST z+,temp
	cpi ZH, HIGH(RAMEND-1)	; Vergleich?		
	brlo SRAM_CLEAR_w		; kleiner => SPRUNG	
	cpi ZL, LOW(RAMEND-1)	; Vergleich?		
	brlo SRAM_CLEAR_w		; kleiner => SPRUNG	
	breq SRAM_CLEAR_w		; gleich  => SPRUNG	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
PORT_CLEAR:
	clr temp
	out DDRB, temp
	out DDRC, temp
	out DDRD, temp
	out PORTB,temp				
	out PORTC,temp				
	out PORTD,temp	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
REGISTER_CLEAR:
	clr R0
	clr R1
	clr R2
	clr R3
	clr R4
	clr R5
	clr R6
	clr R7
	clr R8
	clr R9
	clr R10
	clr R11
	clr R12
	clr R13
	clr R14
	clr R15
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
PORT_INITIALISIERUNG:
	; auf AUSGANG								
	sbi (LED_GRUEN_DDR),(LED_GRUEN_PIN_NR)		; GRN	
	sbi (LED_GELB_DDR) ,(LED_GELB_PIN_NR)		; GELB	
	sbi (LED_ROT_DDR)  ,(LED_ROT_PIN_NR)		; ROT	
	rcall WAIT_500ms
	LED_GRUEN_OFF
	LED_GELB_OFF
	LED_ROT_OFF
;-------------------------------------------------------------------------------
	sbi (A0_DDR),(A0_PIN_NR)					; Motor-A
	sbi (A1_DDR),(A1_PIN_NR)					; Motor-A
	sbi (B0_DDR),(B0_PIN_NR)					; Motor-B
	sbi (B1_DDR),(B1_PIN_NR)					; Motor-B
;-------------------------------------------------------------------------------
	cbi (TASTE_A_DDR),(TASTE_A_PIN_NR)	; auf EINGANG		
	cbi (TASTE_B_DDR),(TASTE_B_PIN_NR)
	sbi (TASTE_A_PORT),(TASTE_A_PIN_NR)	; PULL-UP ein		
	sbi (TASTE_B_PORT),(TASTE_B_PIN_NR)
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
PROGRAMM_STOP:
	WDR
	LED_GRUEN_ON
	LED_GELB_OFF
	LED_ROT_OFF
	rcall WAIT_100ms
	LED_GRUEN_OFF
	rcall WAIT_100ms
rjmp PROGRAMM_STOP
; ##############################################################################
; ##############################################################################
; ##############################################################################
PROGRAMM_NEUSTART:
	LED_GRUEN_ON
	LED_GELB_ON
	LED_ROT_ON
	rjmp PROGRAMM_NEUSTART
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Version: 11/2014																
;																				
;	Division 32 bit-Zahl durch 16 bit Zahl										
;																				
;	input/Output 	temp1 (LOW)	(0...4.294.967.295)								
;	input/Output 	temp2														
;	input/Output 	temp3														
;	input/Output 	temp4 (HIGH)												
;																				
;	input	temp5	Divisor	(LOW)	 											
;	input	temp6	Divisor	(HIGH)	 											
;																				
; Register:	R0+R1	Hilfsregister 												
;			temp	Hilfsregister 												
;																				
DIVISION_32_16:
	; Fehlerprfung		
	tst temp5
	brne FUNKTION_DIVISION_32_16_RUN
	tst temp6
	brne FUNKTION_DIVISION_32_16_RUN
	; Fehler NULL		
	clr temp1
	clr temp2
	clr temp3
	clr temp4
	ret	
;-------------------------------------------------------------------------------
FUNKTION_DIVISION_32_16_RUN:
	push R0
	push R1
	push temp
	; RUNDEN halben Divisor dazuaddieren
	mov R0,temp5		; KOPIE			
	mov R1,temp6
	LSR R1				; durch 2		
	ROR r0
	add temp1,R0		; addieren		
	adc temp2,R1
	adc temp3,NULL
	adc temp4,NULL
;-------------------------------------------------------------------------------
	ldi     temp,32    ;32* schieben	
    clr     R0          ;Rest =0		
    clr     R1
FUNKTION_DIVISION_32_16_1:    
	lsl     temp1       ;Ein Bit aus dem Dividend ...   
    rol     temp2       ;ins Carry schieben
    rol     temp3
    rol     temp4
    rol     R0          ;Carry in den Rest schieben
    rol     R1
    brcs    FUNKTION_DIVISION_32_16_3       ;Bei berlauf von Rest, Sprung
    cp      R0,temp5       					;Solange Bits in temp1 (Rest) schieben bis >= divisor
    cpc     R1,temp6
    brcs    FUNKTION_DIVISION_32_16_2    	;Bei Rest<Divisor, die eingeschobene 0 in temp1 stehen lassen
FUNKTION_DIVISION_32_16_3:
    inc     temp1       ;Ansonsten Bit0 setzen und den Divisor vom Rest abziehen
    sub     R0,temp5
    sbc     R1,temp6
FUNKTION_DIVISION_32_16_2:
   	dec     temp       ;Das ganze 32 mal
    brne    FUNKTION_DIVISION_32_16_1
	pop temp
	pop R1
	pop R0	
ret 
; ##############################################################################
; ##############################################################################
; ##############################################################################
;																						
; 	INPUT:	TEMP1 / TEMP2 	1.Faktor 	(0...65.535 (FF-FF) 							
;			TEMP3 / TEMP4	2.Faktor	(0...65.535 (FF-FF)  							
; 																						
; 	OUTPUT: 	TEMP1...4		Produkt		(4.294.836.225 (FF-FE-00-01)				
; 																						
;	HILFSREGISTER: R0,R1,R2,R3															
; 																						
; rcall FUNKTION_MULTIPLIKATION_16_16	; INP: TEMP1...2 / TEMP3...4 OUT: TEMP1...4 	
;																						
MULTIPLIKATION_16_16:
; Hilfsregister sichern	(STACK)		
	push temp5
	push temp6
	push R0
	push R1
	push R2
	push R3
; Hilfsregister lschen				
	clr temp5
	clr temp6
	clr R0
	clr R1
	clr R2
	clr R3
; SCHLEIFE							
MUL_16_16_w:
	LSR temp4			; 2.Faktor 1x rechts 		
	ROR temp3
	BRCC MUL_16_16_ww	; kein C rollt heraus 		
	add R0, temp1		; 1. FAKOR addieren			
	adc R1, temp2
	adc R2, temp5
	adc R3, temp6
MUL_16_16_ww:	 
	LSL temp1			; 1. FAKOR 1x links			
	ROL temp2
	ROL temp5
	ROL temp6

	TST temp3			; 2.Faktor = NULL (LOW) ?	
	brne MUL_16_16_w
	TST temp4			; 2.Faktor = NULL (HIGH)?	
	brne MUL_16_16_w

	mov temp1, R0		; ERGEBNIS KOPIEREN 		
	mov temp2, R1
	mov temp3, R2
	mov temp4, R3

; REGISTER wieder herstellen (STACK)	
	pop R3
	pop R2
	pop R1
	pop R0
	pop temp6
	pop temp5
ret
