; ##############################################################################
; ##############################################################################
; ##############################################################################
;																				
; Timer 0+1+2 berlauf-Int aktivieren (Timer/Counter Interrupt Mask)			
;																				
TIMER_AKTIVIEREN:
	ldi temp,(0<<OCIE2)|(1<<TOIE2)|(0<<TICIE1)|(0<<OCIE1A)|(0<<OCIE1B)|(0<<TOIE1)|(1<<TOIE0)
	out TIMSK,temp       
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; TIMER0 (8Bit) Vorteiler														
;																				
; CS02 CS01 CS00 	Description													
;	0 	0 	0 		No clock source (Timer/Counter stopped).					
; *	0 	0 	1 		clkI/O/		(No prescaling)									
;	0 	1 	0 		clkI/O/8 	(From prescaler)								
; 	0 	1 	1 		clkI/O/64 	(From prescaler)								
; 	1 	0 	0 		clkI/O/256 	(From prescaler)								
; 	1 	0 	1 		clkI/O/1024 (From prescaler)								
;	1 	1 	0 		External clock source on T0 pin. Clock on falling edge.		
;	1 	1 	1 		External clock source on T0 pin. Clock on rising edge.		
TIMER0_PHASENUNKEHR_INITIALISIERUNG:
.equ TIMER0=(256-30);(2 hoch 8  minus...)

	ldi temp,(0<<CS02)|(0<<CS01)|(1<<CS00)
	OUT TCCR0,temp

	ldi temp,(TIMER0)	
	mov TIMERWERT0,temp
	out TCNT0,temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ersetzt die Hardware-Phasenumkehrschaltung, starke Prozessorauslastung		
TIM0_OVF:
	out TCNT0,TIMERWERT0	

	sbic PINB,1		; Sinus	-
	cbi  PORTD,0
	sbis PINB,1
	sbi  PORTD,0


	sbic PINB,2		; cosinus -
	cbi  PORTD,1
	sbis PINB,2
	sbi  PORTD,1
reti
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Datenblatt Seite 97															
;	 CS12 CS11 CS10 Description													
;		0	0 	0 	No clock source. (Timer/Counter stopped)					
;*		0	0 	1 	clkI/O/1 (No prescaling)									
;		0	1 	0 	clkI/O/8 (From prescaler)									
;		0	1 	1 	clkI/O/64 (From prescaler)									
;		1	0 	0 	clkI/O/256 (From prescaler)									
;		1	0 	1 	clkI/O/1024 (From prescaler)								
;		1	1 	0 	External clock source on T1 pin. Clock on falling edge.		
;		1	1 	1 	External clock source on T1 pin. Clock on rising edge.      
; PWM fr Sinus und Cosinus														
TIMER1_PWM_INITIALISIERUNG:
;	ldi     temp,(1<<COM1A0)|(1<<COM1A1)|(1<<COM1B0)|(1<<COM1B1)|(0<<WGM11)|(1<<WGM10); 8Bit  invertiert		
;	ldi     temp,(0<<COM1A0)|(1<<COM1A1)|(0<<COM1B0)|(1<<COM1B1)|(0<<WGM11)|(1<<WGM10); 8Bit  nicht invertiert
;	ldi     temp,(0<<COM1A0)|(1<<COM1A1)|(0<<COM1B0)|(1<<COM1B1)|(1<<WGM11)|(0<<WGM10); 9Bit  nicht invertiert
	ldi     temp,(0<<COM1A0)|(1<<COM1A1)|(0<<COM1B0)|(1<<COM1B1)|(1<<WGM11)|(1<<WGM10);10Bit  nicht invertiert
	out     TCCR1A,temp              

	ldi     temp,(1<<WGM12)|(0<<CS12)|(0<<CS11)|(1<<CS10)	;VT:1	PWM 62.500	31.250	15.625 Hz
;	ldi     temp,(1<<WGM12)|(0<<CS12)|(1<<CS11)|(0<<CS10)	;VT:8   PWM  7.813	 3.906	 1.953 Hz
;	ldi     temp,(1<<WGM12)|(0<<CS12)|(1<<CS11)|(1<<CS10)	;VT:64  PWM    977	   488	   244 Hz
;	ldi     temp,(1<<WGM12)|(1<<CS12)|(0<<CS11)|(0<<CS10)	;VT:256 PWM    244	   122	    61 Hz
;	ldi     temp,(1<<WGM12)|(1<<CS12)|(0<<CS11)|(1<<CS10)	;VT:1024PWM     61	    31	    15 Hz
	out     TCCR1B,temp   

.equ START=(1023/2)		; 8,9,10Bit

	ldi temp1, low(START)
	ldi temp2,high(START)
	out OCR1AH,temp2	; zuerst H
	out OCR1AL,temp1	; dann   L

	ldi temp1, low(START)
	ldi temp2,high(START)
	out OCR1BH,temp2	; zuerst H
	out OCR1BL,temp1	; dann   L


;sbi DDRB,1 		; auf Ausgang	
;sbi DDRB,2 		; auf Ausgang	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; TIMER2 (8Bit) Vorteiler														
;																				
; TCCR2 ==> FOC2 WGM20 COM21 COM20 WGM21 CS22 CS21 CS20 						
; CS22 CS21 CS20 Description													
;	0	0 	0 	No clock source (Timer/Counter stopped).						
;	0 	0 	1 	clkT2S/		(No prescaling)										
; 	0 	1 	0 	clkT2S/8 	(From prescaler)									
;	0 	1 	1 	clkT2S/32 	(From prescaler)									
; *	1 	0 	0 	clkT2S/64 	(From prescaler)									
;	1 	0 	1 	clkT2S/128 	(From prescaler)									
;	1 	1 	0 	clkT2S/256 	(From prescaler)									
;	1 	1 	1 	clkT2S/1024 (From prescaler)									
; TIMER2 (8Bit) Vorteiler														
;																				
; TCCR2 ==> FOC2 WGM20 COM21 COM20 WGM21 CS22 CS21 CS20 						
; CS22 CS21 CS20 Description													
;	0	0 	0 	No clock source (Timer/Counter stopped).						
;	0 	0 	1 	clkT2S/		(No prescaling)										
; 	0 	1 	0 	clkT2S/8 	(From prescaler)									
;	0 	1 	1 	clkT2S/32 	(From prescaler)									
; *	1 	0 	0 	clkT2S/64 	(From prescaler)									
;	1 	0 	1 	clkT2S/128 	(From prescaler)									
;	1 	1 	0 	clkT2S/256 	(From prescaler)									
;	1 	1 	1 	clkT2S/1024 (From prescaler)									
TIMER2_1ms_INITIALISIERUNG:
.equ TIMERWERT2=(256-250)		;(2 hoch 8  minus...)16MHz VT:64--->250
	ldi temp,(1<<CS22)|(0<<CS21) |(0<<CS20)  
	out TCCR2,temp  
	ldi temp,(TIMERWERT2)		; Startwert
	out TCNT2,temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 1ms																			
TIM2_OVF:
	SEI
	LED_GRUEN_OFF
	push TEMP		    	; Sichern von "TEMP" im Stack			
	in	 TEMP,SREG			; Einlesen des SREG 					
	push TEMP	    		; Schreiben von  SREG  im Stack (KOPIE)	
	push TEMP1
;-------------------------------------------------------------------------------
	ldi temp,(TIMERWERT2)	; Startwert
	out TCNT2,temp
;-------------------------------------------------------------------------------
; UHR-ms (Millisekunden)														
	LDS temp,(adr_1ms)
	inc temp
	cpi temp,10
	brsh TIM2_10ms
	STS(adr_1ms),temp
	rjmp TIM2_OVF_FERTIG
;-------------------------------------------------------------------------------
TIM2_10ms:
	STS(adr_1ms),NULL	; NULL	
	LDS temp,(adr_10ms)
	inc temp
	cpi temp,10
	brsh TIM2_100ms
	STS(adr_10ms),temp
	rjmp TIM2_OVF_FERTIG
;-------------------------------------------------------------------------------
TIM2_100ms:
	STS(adr_10ms),NULL	; NULL	

	LDS temp,(adr_KONSTANTE_L)
	add ZEITZAHL_0,temp
	LDS temp,(adr_KONSTANTE_H)
	adc ZEITZAHL_1,temp
	adc ZEITZAHL_2,NULL
	adc ZEITZAHL_3,NULL

	LDS temp,(adr_100ms)
	inc temp
	cpi temp,10
	brsh TIM2_1s
	STS(adr_100ms),temp
	rjmp TIM2_OVF_FERTIG
;-------------------------------------------------------------------------------
TIM2_1s:
	LED_GRUEN_ON
	STS(adr_100ms),NULL	; NULL	

	rcall UHR				; UHR
;-------------------------------------------------------------------------------
TIM2_OVF_FERTIG:
	pop TEMP1
	pop	TEMP			; LESEN von SREG vom STACK (KOPIE)
	out	SREG,TEMP		; Wiederherstellen von SREG
	pop	TEMP			; Wiederherstellen von "TEMP" 		
reti
; ##############################################################################
; ##############################################################################
; ##############################################################################
UHR:
	LDS temp,(adr_MENUE_TIMER)
	tst temp
	breq UHR_ss
	dec temp
	STS(adr_MENUE_TIMER),temp
;-------------------------------------------------------------------------------
UHR_ss:
	LDS temp,(adr_ss)
	inc temp
	cpi temp,60
	brsh UHR_mm
	STS (adr_ss),temp
	ret
;-------------------------------------------------------------------------------
UHR_mm:
	STS (adr_ss),NULL
	LDS temp,(adr_mm)
	inc temp
	cpi temp,60
	brsh UHR_hh
	STS (adr_mm),temp
	ret
;-------------------------------------------------------------------------------
UHR_hh:
	STS (adr_mm),NULL
	LDS temp,(adr_hh)
	inc temp
	cpi temp,24
	brsh UHR_hh_NULL
	STS (adr_hh),temp
	ret
;-------------------------------------------------------------------------------
; TAG																			
UHR_hh_NULL:
	STS (adr_hh),NULL
	rcall UHR_NULL
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
UHR_NULL:
	clr ZEITZAHL_0
	clr ZEITZAHL_1
	clr ZEITZAHL_2
	clr ZEITZAHL_3

	STS(adr_POSITION_IST_0),NULL
	STS(adr_POSITION_IST_1),NULL
	STS(adr_POSITION_IST_2),NULL

	STS(adr_1ms),NULL	
	STS(adr_10ms),NULL	
	STS(adr_100ms),NULL	
	STS(adr_ss),NULL
	STS(adr_mm),NULL
	STS(adr_hh),NULL
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
